package EditorTxtEnDirecto;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

public class EditorTxtEnDirecto {

    private static final Scanner lector = new Scanner(System.in);

    public static void main(String[] args) {

        final char STOPPER = '\\';
        String pathContainer = "C:\\Users\\jandr\\Desktop\\Acceso a datos\\Container Ficheros";
        String fileName = "Ejercicio5_0310.txt";

        //Creamos el archivo
        File f = makeFile(pathContainer, fileName);

        //Rellenamos el archivo
        String finalInput = "";
        System.out.println("\n>Escriba lo que desee.");

        boolean validate = false;
        while (!validate) {

            String userInput = readString();

            //Iteramos lo introducido CHAR por CHAR por si aparece la '\'
            for(int i = 0; i < userInput.length(); i++) {
                if(userInput.charAt(i) == STOPPER) {
                    System.out.println("\n- Caracter stopper.");
                    userInput = "";
                    validate = true;
                }
            }

            finalInput += userInput;

        };

        //Rellenamos el archivo
        fillFile(f, finalInput);
        System.out.println("\n+ Se ha terminado la ejecución.");

    }

    /**
     * Lee y devuelve un String
     * @return
     */
    public static String readString() {
        return lector.nextLine();
    }

    /**
     * Creará un archivo con el nombre archivo
     * @param directory
     * @param file
     * @return
     */
    public static File makeFile(String directory, String file) {

        File f = new File(directory + File.separator + file);

        if (f != null) {
            try {
                if (f.createNewFile())
                    return f;
            } catch (IOException e) {
                System.out.println("- Ha surgido un problema... \n(i) It exists: " + f.exists() + "\tLength: " + f.length());
            }
        }

        return null;

    }

    /**
     * Rellena el File/Archivo con el String pasado
     * Los saltos de linea -\n- si que los cuenta.
     * @param f
     * @param content
     */
    public static void fillFile(File f, String content) {

        if (f.exists() && f.isFile()) {
            try (BufferedWriter bw = new BufferedWriter(new FileWriter(f.getPath()))) {
                bw.write(content);
            } catch (FileNotFoundException fnf) {
                System.out.println("\n- Ha saltado una excepción FNF ... " + fnf.getMessage());
            } catch (IOException io) {
                System.out.println("\n- Ha saltado una excepción I/O ... " + io.getMessage());
            }
        } else {
            System.out.println("\n- El archivo no existe ... ");
        }

    }

}
